Index: main/waeup.ikoba/trunk/layout/rules.xml
===================================================================
--- main/waeup.ikoba/trunk/layout/rules.xml	(revision 12169)
+++ main/waeup.ikoba/trunk/layout/rules.xml	(revision 12170)
@@ -61,6 +61,6 @@
              css:content-children="ul.breadcrumb" />
 
-    <!-- student status -->
-    <drop css:theme="div.ikoba-student-status-box"
+    <!-- customer status -->
+    <drop css:theme="div.ikoba-customer-status-box"
           css:if-not-content="div.wfstatus" />
     <replace css:theme-children="div.wfstatus"
Index: main/waeup.ikoba/trunk/layout/static/css/base.css
===================================================================
--- main/waeup.ikoba/trunk/layout/static/css/base.css	(revision 12169)
+++ main/waeup.ikoba/trunk/layout/static/css/base.css	(revision 12170)
@@ -69,5 +69,5 @@
 .ikoba-breadcrumbs-box-short,
 .ikoba-breadcrumbs-box-long,
-.ikoba-student-status-box {
+.ikoba-customer-status-box {
     padding: 0px 5px 0px 5px;
 }
@@ -85,5 +85,5 @@
 .ikoba-breadcrumbs-box-short .well,
 .ikoba-breadcrumbs-box-long .well,
-.ikoba-student-status-box .well {
+.ikoba-customer-status-box .well {
     padding: 5px 5px 5px 5px;
 }
@@ -104,5 +104,5 @@
 }
 
-.ikoba-student-status-box .well {
+.ikoba-customer-status-box .well {
     background-color: #909090;
 }
@@ -328,5 +328,5 @@
   .ikoba-breadcrumbs-box-short,
   .ikoba-breadcrumbs-box-long,
-  .ikoba-student-status-box {
+  .ikoba-customer-status-box {
       padding: 0px 0px 0px 0px;
   }
Index: main/waeup.ikoba/trunk/layout/theme.html
===================================================================
--- main/waeup.ikoba/trunk/layout/theme.html	(revision 12169)
+++ main/waeup.ikoba/trunk/layout/theme.html	(revision 12170)
@@ -50,8 +50,6 @@
            id="ikoba-primary-nav">
         <ul class="nav navbar-nav ikoba-navbar-left">
-          <li class="active"><a href="#">Academics</a></li>
-          <li><a href="#about">Applicants</a></li>
-          <li><a href="#contact">Students</a></li>
-          <li><a href="#contact">Hostels</a></li>
+          <li class="active"><a href="#">Products</a></li>
+          <li><a href="#about">Customers</a></li>
           <li class="dropdown">
             <a href="#" class="dropdown-toggle"
@@ -60,6 +58,6 @@
             <ul class="dropdown-menu">
               <li><a href="#">Base Data</a></li>
-              <li><a href="#">Clearance Data</a></li>
-              <li><a href="#">Personal Data</a></li>
+              <li><a href="#">Documents</a></li>
+              <li><a href="#">Contracts</a></li>
               <li><a href="#">History</a></li>
             </ul>
@@ -146,11 +144,11 @@
         </div> <!-- /ikoba-breadcrumbs-box-short -->
 
-        <div class="col-md-4 container ikoba-student-status-box">
+        <div class="col-md-4 container ikoba-customer-status-box">
           <div class="well">
             <div class="wfstatus">
-                K1000000 &bull; quite long student status
+                K1000000 &bull; quite long customer status
             </div> <!-- /wfstatus -->
           </div> <!-- /well -->
-        </div> <!-- /ikoba-student-status-box -->
+        </div> <!-- /ikoba-customer-status-box -->
 
       </div> <!-- /row -->
@@ -160,12 +158,9 @@
           <div class="sidebar-nav well">
             <div>
-              <div class="ikoba-sidebar-title">Student Name</div>
+              <div class="ikoba-sidebar-title">Customer Name</div>
               <ul class="nav">
                 <li><a href="#">Base Data</a></li>
-                <li><a href="#">Clearance Data</a></li>
-                <li><a href="#">Personal Data</a></li>
-                <li><a href="#">Study Course</a></li>
-                <li><a href="#">Payments</a></li>
-                <li><a href="#">Accommodation</a></li>
+                <li><a href="#">Documents</a></li>
+                <li><a href="#">Contracts</a></li>
                 <li><a href="#">History</a></li>
               </ul>
@@ -178,5 +173,4 @@
                 <li><a href="#">Data Center</a></li>
                 <li><a href="#">Reports</a></li>
-                <li><a href="#">Access Codes</a></li>
                 <li><a href="#">My Preferences</a></li>
                 <li><a href="#">My Roles</a></li>
@@ -387,20 +381,13 @@
               <div class="form-group">
                 <input class="btn btn-primary" type="submit" name="search"
-                  value="Find student(s)" />
+                  value="Find customers(s)" />
               </div>
               <div class="form-group">
                 <select name="searchtype" class="form-control">
-                  <option value="student_id">with id</option>
+                  <option value="customer_id">with id</option>
                   <option value="fullname">with name</option>
                   <option value="reg_number">with registration number</option>
-                  <option value="matric_number">with matric number</option>
-                  <option value="current_session">in session</option>
-                  <option value="depcode">in department</option>
-                  <option value="current_mode">in study mode</option>
                   <option value="suspended">
                     with deactivated account (search term omitted)
-                  </option>
-                  <option value="transcript">
-                    who requested transcript (search term omitted)
                   </option>
                 </select>
@@ -473,6 +460,5 @@
                 <tr>
                   <td class="fieldname">*
-                      Application Mode
-                      (A select field coming from zope.formlib):
+                      A select field coming from zope.formlib:
                   </td>
                   <td>
@@ -480,7 +466,7 @@
                       <select id="form.mode" name="form.mode" size="1">
                         <option selected="selected" value="create">
-                          Create Application Records
+                          Create Records
                         </option>
-                        <option value="update">Update Application Records
+                        <option value="update">Update Records
                         </option>
                       </select>
@@ -507,8 +493,8 @@
                               class="form-control half">
                         <option selected="selected" value="create">
-                            Create Application Records
+                            Create Records
                         </option>
                         <option value="update">
-                            Update Application Records
+                            Update Records
                         </option>
                       </select>
Index: main/waeup.ikoba/trunk/tools/download_exports.sh
===================================================================
--- main/waeup.ikoba/trunk/tools/download_exports.sh	(revision 12169)
+++ 	(revision )
@@ -1,13 +1,0 @@
-#!/bin/sh
-
-## We expect at least three arguments...
-if [ $# -ne 3 ]; then
-    echo "Usage: $0 [user name] [password] [exporter]"
-    exit
-fi
-
-wget --save-cookies cookies.txt --keep-session-cookies --post-data "form.login=$1&form.password=$2" https://uniben-kofa.waeup.org/login 
-wget --load-cookies cookies.txt  --output-document $3.csv https://uniben-kofa.waeup.org/datacenter/export.csv?exporter=$3
-tar -czf Kofa$3.tar.gz $3.csv
-rm $3.csv
-mv Kofa$3.tar.gz /home/ftp/uniben
Index: main/waeup.ikoba/trunk/tools/prepare_jamb_file.py
===================================================================
--- main/waeup.ikoba/trunk/tools/prepare_jamb_file.py	(revision 12169)
+++ 	(revision )
@@ -1,197 +1,0 @@
-## $Id$
-## 
-## Copyright (C) 2012 Uli Fouquet & Henrik Bettermann
-## This program is free software; you can redistribute it and/or modify
-## it under the terms of the GNU General Public License as published by
-## the Free Software Foundation; either version 2 of the License, or
-## (at your option) any later version.
-## 
-## This program is distributed in the hope that it will be useful,
-## but WITHOUT ANY WARRANTY; without even the implied warranty of
-## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-## GNU General Public License for more details.
-## 
-## You should have received a copy of the GNU General Public License
-## along with this program; if not, write to the Free Software
-## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
-##
-"""
-"""
-import csv
-import datetime
-import re
-import sys
-
-##
-## CONFIGURATION SECTION
-##
-# keys are fieldnames in input file, values are methods of class
-# Converter (see below)
-OPTIONS = {
-    'sex': 'gender',
-    'session': 'session',
-    'lga': 'lga',
-    'firstname': 'name',
-    'middlename': 'name',
-    'lastname': 'uppername',
-    'container_code': 'container_code',
-    }
-
-# Mapping input file colnames --> output file colnames
-COLNAME_MAPPING = {
-    'jambscore': 'jamb_score',
-    'eng_score': 'jamb_subjects',
-    }
-
-##
-## END OF CONFIG
-##
-
-# Look for the first sequence of numbers
-RE_PHONE = re.compile('[^\d]*(\d*)[^\d]*')
-
-def convert_fieldnames(fieldnames):
-    """Replace input fieldnames by fieldnames of COLNAME_MAPPING.
-    """
-    header = dict([(name, name) for name in fieldnames])
-    for in_name, out_name in COLNAME_MAPPING.items():
-        if in_name not in header:
-            continue
-        header[in_name] = out_name
-    return header
-
-def merge_subjects(row):
-    """Merge jamb subjects and scores into one field.
-    """
-    if 'eng_score' in row and 'Subj2'	in row and 'Subj2Score' in row \
-        and 'Subj3' in row and 'Subj3Score' in row and 'Subj4' in row  \
-        and 'Subj4Score' in row:
-        subjectstring = "English: %s, %s: %s, %s: %s, %s: %s"
-        row['eng_score'] =  subjectstring % (
-            row['eng_score'],
-            row['Subj2'], row['Subj2Score'],
-            row['Subj3'], row['Subj3Score'],
-            row['Subj4'], row['Subj4Score'],
-            )
-    else:
-        pass
-
-class Converters():
-    """Converters to turn old-style values into new ones.
-    """
-
-    @classmethod
-    def name(self, value):
-        """ 'JOHN -> John'
-        """
-        return value.capitalize()
-
-    @classmethod
-    def uppername(self, value):
-        """ 'John -> JOHN'
-        """
-        return value.upper()
-
-    @classmethod
-    def container_code(self, value):
-        """ Return constant string.
-        """
-        return 'putme2012'
-
-    @classmethod
-    def lga(self, value):
-        """ 
-        """
-        if value == 'akwa_ibom_uru_offong_oruko':
-            return 'akwa_ibom_urue-offong-oruko'
-        if value == 'edo_akoko_edo':
-            return 'edo_akoko-edo'
-        if value == 'edo_owan_east':
-            return 'edo_owan-east'
-        if value == 'kogi_mopa-muro-mopi':
-            return 'kogi_mopa-muro'
-        if value == 'foreign':
-            return 'foreigner'
-        try:
-            value = value.replace("'","")
-            value = value.lower()
-        except:
-            return ''
-        return value
-
-
-    @classmethod
-    def session(self, value):
-        """ '08' --> '2008'
-        '2008/2009' --> '2008'
-        """
-        if '/' in value:
-            numbers = value.split('/')
-            number = int(numbers[0])
-            if number in range(2000,2015):
-                return number
-            else:
-                return 9999
-        try:
-            number = int(value)
-        except ValueError:
-            #import pdb; pdb.set_trace()
-            return 9999
-        if number < 14:
-            return number + 2000
-        elif number in range(2000,2015):
-            return number
-        else:
-            return 9999
-
-    @classmethod
-    def gender(self, value):
-        """ 'True'/'False' --> 'f'/'m'
-            'F'/'M' --> 'f'/'m'
-        """
-        if value in ('True','f','F'):
-            value = 'f'
-        elif value in ('False','m','M'):
-            value = 'm'
-        else:
-            value = ''
-        return value
-
-
-def main():
-    input_file = '%s' % sys.argv[1]
-    output_file = '%s_edited.csv' % sys.argv[1].split('.')[0]
-    reader = csv.DictReader(open(input_file, 'rb'))
-    writer = None
-
-    for num, row in enumerate(reader):
-        if num == 0:
-            writer = csv.DictWriter(open(output_file, 'wb'), reader.fieldnames)
-            print "FIELDS: "
-            for x, y in enumerate(reader.fieldnames):
-                print x, y
-            header = convert_fieldnames(reader.fieldnames)
-            writer.writerow(header)
-        merge_subjects(row)
-        for key, value in row.items():
-            if not key in OPTIONS.keys():
-                continue
-            conv_name = OPTIONS[key]
-            converter = getattr(Converters, conv_name, None)
-            if converter is None:
-                print "WARNING: cannot find converter %s" % conv_name
-                continue
-            row[key] = converter(row[key])
-        try:
-            writer.writerow(row)
-        except:
-            print row['reg_number']
-
-    print "Output written to %s" % output_file
-
-
-if __name__ == '__main__':
-    if len(sys.argv) != 2:
-        print 'Usage: %s <filename>' % __file__
-        sys.exit(1)
-    main()
Index: main/waeup.ikoba/trunk/versions.cfg
===================================================================
--- main/waeup.ikoba/trunk/versions.cfg	(revision 12169)
+++ main/waeup.ikoba/trunk/versions.cfg	(revision 12170)
@@ -158,5 +158,5 @@
 
 # Required by:
-# waeup.ikoba==1.3dev
+# waeup.ikoba==0.2dev
 psutil = 2.1.1
 six = 1.5.2