Index: main/waeup.fceokene/trunk/src/waeup/fceokene/students/tests/test_browser.py
===================================================================
--- main/waeup.fceokene/trunk/src/waeup/fceokene/students/tests/test_browser.py	(revision 12187)
+++ main/waeup.fceokene/trunk/src/waeup/fceokene/students/tests/test_browser.py	(revision 12188)
@@ -228,5 +228,5 @@
         self.assertEqual(payment.p_level, 100)
         self.assertEqual(payment.p_session, 2004)
-        self.assertEqual(payment.amount_auth, 13245.0)
+        self.assertEqual(payment.amount_auth, 14975.0)
         self.assertEqual(payment.p_item, u'CERT1')
         self.assertEqual(error, None)
@@ -241,5 +241,5 @@
         self.assertEqual(payment.p_level, 200)
         self.assertEqual(payment.p_session, 2005)
-        self.assertEqual(payment.amount_auth, 12295.0)
+        self.assertEqual(payment.amount_auth, 14025.0)
         self.assertEqual(payment.p_item, u'CERT1')
         self.assertEqual(error, None)
@@ -281,5 +281,5 @@
         self.assertEqual(payment.p_level, 100)
         self.assertEqual(payment.p_session, 2004)
-        self.assertEqual(payment.amount_auth, 4150.0)
+        self.assertEqual(payment.amount_auth, 5150.0)
         self.assertEqual(payment.p_item, u'My bed coordinates')
         self.assertEqual(error, None)
Index: main/waeup.fceokene/trunk/src/waeup/fceokene/students/utils.py
===================================================================
--- main/waeup.fceokene/trunk/src/waeup/fceokene/students/utils.py	(revision 12187)
+++ main/waeup.fceokene/trunk/src/waeup/fceokene/students/utils.py	(revision 12188)
@@ -140,5 +140,5 @@
                 amount = 2500.0 #removed interswitch fee
             else:
-                amount = 4000.0 #removed interswitch fee
+                amount = 5000.0 #removed interswitch fee
         elif category == 'clearance':
             amount = academic_session.clearance_fee
@@ -181,47 +181,47 @@
                 if student.current_level == 10 and student.state == CLEARED:
                     if student.depcode in ARTS:
-                        amount = 15500
-                    else:
-                        amount = 16000
+                        amount = 17500
+                    else:
+                        amount = 18000
                 # NCE I fresh
                 elif student.current_level == 100 and student.state == CLEARED:
                     if student.depcode in ARTS:
-                        amount = 12620
-                    else:
-                        amount = 13095
+                        amount = 14325
+                    else:
+                        amount = 14825
                 # NCE II
                 elif student.current_level in (100, 110, 120) and \
                     student.state == RETURNING:
                     if student.depcode in ARTS:
-                        amount = 11670
-                    else:
-                        amount = 12145
+                        amount = 13375
+                    else:
+                        amount = 13875
                 # NCE III
                 elif student.current_level in (200, 210, 220):
                     if student.depcode in ARTS:
-                        amount = 11670
-                    else:
-                        amount = 12145
+                        amount = 13375
+                    else:
+                        amount = 13875
                 # NCE III repeater
                 elif student.current_level in (300, 310, 320) and \
                     student.current_verdict == 'O':
                     if student.depcode in ARTS:
-                        amount = 9770
-                    else:
-                        amount = 10245
+                        amount = 11475
+                    else:
+                        amount = 11975
                 # NCE III spillover
                 elif student.current_level in (300, 310, 320) and \
                     student.current_verdict == 'B':
                     if student.depcode in ARTS:
-                        amount = 9770
-                    else:
-                        amount = 10245
+                        amount = 11975
+                    else:
+                        amount = 11975
                 # NCE III second spillover
                 elif student.current_level in (400, 410, 420) and \
                     student.current_verdict == 'B':
                     if student.depcode in ARTS:
-                        amount = 9770
-                    else:
-                        amount = 10245
+                        amount = 11975
+                    else:
+                        amount = 11975
             else:
                 if student.current_level == 100 and student.state == CLEARED: