Index: main/waeup.ikoba/trunk/src/waeup/ikoba/app.py
===================================================================
--- main/waeup.ikoba/trunk/src/waeup/ikoba/app.py	(revision 12206)
+++ main/waeup.ikoba/trunk/src/waeup/ikoba/app.py	(revision 12207)
@@ -34,4 +34,5 @@
 from waeup.ikoba.customers.container import CustomersContainer
 from waeup.ikoba.products.container import ProductsContainer
+from waeup.ikoba.documents.container import DocumentsContainer
 
 
@@ -107,4 +108,5 @@
         self['customers'] = CustomersContainer()
         self['products'] = ProductsContainer()
+        self['documents'] = DocumentsContainer()
         self._createPlugins()
 
Index: main/waeup.ikoba/trunk/src/waeup/ikoba/customers/tests/test_browser.py
===================================================================
--- main/waeup.ikoba/trunk/src/waeup/ikoba/customers/tests/test_browser.py	(revision 12206)
+++ main/waeup.ikoba/trunk/src/waeup/ikoba/customers/tests/test_browser.py	(revision 12207)
@@ -826,5 +826,5 @@
         self.assertEqual(self.browser.url, self.customer_path)
         self.browser.open(self.customer_path)
-        self.browser.getLink("Documents").click()
+        self.browser.getLink("Documents", index=1).click()
         self.browser.getLink("Add document").click()
         self.browser.getControl(name="doctype").value = ['CustomerPDFDocument']
@@ -865,5 +865,5 @@
 
         # Documents can be removed
-        self.browser.getLink("Documents").click()
+        self.browser.getLink("Documents", index=1).click()
         ctrl = self.browser.getControl(name='val_id')
         ctrl.getControl(value=document.document_id).selected = True
Index: main/waeup.ikoba/trunk/src/waeup/ikoba/documents/container.py
===================================================================
--- main/waeup.ikoba/trunk/src/waeup/ikoba/documents/container.py	(revision 12206)
+++ main/waeup.ikoba/trunk/src/waeup/ikoba/documents/container.py	(revision 12207)
@@ -21,4 +21,5 @@
 import grok
 from grok import index
+from waeup.ikoba.interfaces import IIkobaPluggable
 from waeup.ikoba.documents.interfaces import IDocumentsContainer, IDocument
 from waeup.ikoba.utils.helpers import attrs_to_fields
@@ -39,2 +40,20 @@
 
 DocumentsContainer = attrs_to_fields(DocumentsContainer)
+
+class DocumentsPlugin(grok.GlobalUtility):
+    """A plugin that creates container for documents inside a company.
+    """
+    grok.implements(IIkobaPluggable)
+    grok.name('documents')
+
+    def setup(self, site, name, logger):
+        if 'documents' in site.keys():
+            logger.warn('Could not create container for documents.')
+            return
+        site['documents'] = DocumentsContainer()
+        logger.info('Container for documents created')
+        return
+
+    def update(self, site, name, logger):
+        if not 'documents' in site.keys():
+            self.setup(site, name, logger)
Index: main/waeup.ikoba/trunk/src/waeup/ikoba/permissions.py
===================================================================
--- main/waeup.ikoba/trunk/src/waeup/ikoba/permissions.py	(revision 12206)
+++ main/waeup.ikoba/trunk/src/waeup/ikoba/permissions.py	(revision 12207)
@@ -132,4 +132,5 @@
                      'waeup.manageUsers',
                      'waeup.viewProducts', 'waeup.manageProducts',
+                     'waeup.viewDocuments', 'waeup.manageDocuments',
                      'waeup.manageDataCenter',
                      'waeup.importData',
@@ -157,4 +158,5 @@
                      #'waeup.manageUsers',
                      'waeup.viewProducts', 'waeup.manageProducts',
+                     'waeup.viewDocuments', 'waeup.manageDocuments',
                      #'waeup.manageACBatches',
                      'waeup.manageDataCenter',
Index: main/waeup.ikoba/trunk/src/waeup/ikoba/permissions.txt
===================================================================
--- main/waeup.ikoba/trunk/src/waeup/ikoba/permissions.txt	(revision 12206)
+++ main/waeup.ikoba/trunk/src/waeup/ikoba/permissions.txt	(revision 12207)
@@ -39,8 +39,8 @@
     >>> from waeup.ikoba.permissions import get_waeup_roles
     >>> len(list(get_waeup_roles()))
-    13
+    15
 
     >>> len(list(get_waeup_roles(also_local=True)))
-    16
+    19
 
 
@@ -58,4 +58,6 @@
     u'waeup.CustomersOfficer',
     u'waeup.DataCenterManager',
+    u'waeup.DocumentsManager',
+    u'waeup.DocumentsOfficer',
     u'waeup.ExportManager',
     u'waeup.ImportManager',