Index: main/waeup.ikoba/trunk/src/waeup/ikoba/customers/browser.py
===================================================================
--- main/waeup.ikoba/trunk/src/waeup/ikoba/customers/browser.py	(revision 12209)
+++ main/waeup.ikoba/trunk/src/waeup/ikoba/customers/browser.py	(revision 12210)
@@ -841,5 +841,5 @@
     grok.require('waeup.viewCustomer')
     grok.template('documentpage')
-    form_fields = grok.AutoFields(ICustomerDocument).omit('last_transition_date')
+    form_fields = grok.AutoFields(ICustomerDocument)
     pnav = 4
 
@@ -856,5 +856,5 @@
     grok.require('waeup.manageCustomer')
     grok.template('documenteditpage')
-    form_fields = grok.AutoFields(ICustomerDocument).omit('last_transition_date')
+    form_fields = grok.AutoFields(ICustomerDocument)
     pnav = 4
     deletion_warning = _('Are you sure?')
@@ -1008,6 +1008,4 @@
                    'suspended_comment',)
 
-    #form_fields = grok.AutoFields(ICustomerPDFDocument).omit(
-    #    'last_transition_date')
     form_fields =()
 
@@ -1180,6 +1178,5 @@
     @property
     def form_fields(self):
-        form_fields = grok.AutoFields(self.context.form_fields_interface).omit(
-            'last_transition_date')
+        form_fields = grok.AutoFields(self.context.form_fields_interface)
         for field in form_fields:
             if field.__name__.endswith('_object'):
@@ -1204,6 +1201,5 @@
     @property
     def form_fields(self):
-        return grok.AutoFields(self.context.form_fields_interface).omit(
-            'last_transition_date')
+        return grok.AutoFields(self.context.form_fields_interface)
 
     @property
@@ -1225,6 +1221,5 @@
     @property
     def form_fields(self):
-        return grok.AutoFields(self.context.edit_form_fields_interface).omit(
-            'last_transition_date')
+        return grok.AutoFields(self.context.edit_form_fields_interface)
 
     def update(self):
@@ -1354,6 +1349,5 @@
                    'suspended_comment',)
 
-    form_fields = grok.AutoFields(ISampleContract).omit(
-        'last_transition_date')
+    form_fields = grok.AutoFields(ISampleContract)
 
     @property
Index: main/waeup.ikoba/trunk/src/waeup/ikoba/customers/contracts.py
===================================================================
--- main/waeup.ikoba/trunk/src/waeup/ikoba/customers/contracts.py	(revision 12209)
+++ main/waeup.ikoba/trunk/src/waeup/ikoba/customers/contracts.py	(revision 12210)
@@ -107,6 +107,6 @@
     def formatted_transition_date(self):
         try:
-            return self.last_transition_date.strftime('%Y-%m-%d %H:%M:%S')
-        except AttributeError:
+            return self.history.messages[-1].split(' - ')[0]
+        except IndexError:
             return
 
Index: main/waeup.ikoba/trunk/src/waeup/ikoba/customers/interfaces.py
===================================================================
--- main/waeup.ikoba/trunk/src/waeup/ikoba/customers/interfaces.py	(revision 12209)
+++ main/waeup.ikoba/trunk/src/waeup/ikoba/customers/interfaces.py	(revision 12210)
@@ -286,10 +286,4 @@
         )
 
-    last_transition_date = schema.Datetime(
-        title = _(u'Last Transition Date'),
-        required = False,
-        readonly = False,
-        )
-
     product_object = schema.Choice(
         title = _(u'Product'),
Index: main/waeup.ikoba/trunk/src/waeup/ikoba/customers/tests/test_export.py
===================================================================
--- main/waeup.ikoba/trunk/src/waeup/ikoba/customers/tests/test_export.py	(revision 12209)
+++ main/waeup.ikoba/trunk/src/waeup/ikoba/customers/tests/test_export.py	(revision 12210)
@@ -161,6 +161,6 @@
         self.assertEqual(
             result,
-            'class_name,document_id,history,last_transition_date,state,title,user_id\r\n'
-            'CustomerSampleDocument,d101,[],,,,\r\n'
+            'class_name,document_id,history,state,title,user_id\r\n'
+            'CustomerSampleDocument,d101,[],,,\r\n'
             )
         return
@@ -175,10 +175,10 @@
         result = open(self.outfile, 'rb').read()
         self.assertTrue(
-            'class_name,document_id,history,last_transition_date,state,title,user_id\r\n'
+            'class_name,document_id,history,state,title,user_id\r\n'
             in result
             )
         self.assertMatches(
             '...CustomerSampleDocument,d101,[u\'2014-11-25 06:57:24 UTC - '
-            'Document created by system\'],2014-11-25 06:57:24.990308#,'
+            'Document created by system\'],'
             'verified,My Document,A111111...',
             result
@@ -194,9 +194,9 @@
         result = open(self.outfile, 'rb').read()
         self.assertTrue(
-            'class_name,document_id,history,last_transition_date,state,title,user_id\r\n'
+            'class_name,document_id,history,state,title,user_id\r\n'
             in result)
         self.assertMatches(
             '...CustomerSampleDocument,d101,[u\'2014-11-25 06:57:24 UTC - '
-            'Document created by system\'],2014-11-25 06:57:24.990308#,'
+            'Document created by system\'],'
             'verified,My Document,A111111...',
             result
@@ -212,9 +212,9 @@
         result = open(self.outfile, 'rb').read()
         self.assertTrue(
-            'class_name,document_id,history,last_transition_date,state,title,user_id\r\n'
+            'class_name,document_id,history,state,title,user_id\r\n'
             in result)
         self.assertMatches(
             '...CustomerSampleDocument,d101,[u\'2014-11-25 06:57:24 UTC - '
-            'Document created by system\'],2014-11-25 06:57:24.990308#,'
+            'Document created by system\'],'
             'verified,My Document,A111111...',
             result
@@ -254,8 +254,8 @@
             result,
             'class_name,contract_category,contract_id,document_object,'
-            'history,last_product_id,last_transition_date,'
+            'history,last_product_id,'
             'product_object,state,title\r\n'
 
-            'SampleContract,sample,c101,,[],,,,,\r\n'
+            'SampleContract,sample,c101,,[],,,,\r\n'
             )
         return
@@ -270,10 +270,10 @@
         self.assertMatches(
             'class_name,contract_category,contract_id,document_object,'
-            'history,last_product_id,last_transition_date,'
+            'history,last_product_id,'
             'product_object,state,title\r\n'
 
             'SampleContract,sample,c101,d101,[u\'2014-12-04 12:10:46 UTC - '
             'Contract record created by system\'],,'
-            '2014-12-04 12:10:46.333445#,SAM,created,My Contract\r\n',
+            'SAM,created,My Contract\r\n',
             result
             )
@@ -289,10 +289,10 @@
         self.assertMatches(
             'class_name,contract_category,contract_id,document_object,'
-            'history,last_product_id,last_transition_date,'
+            'history,last_product_id,'
             'product_object,state,title\r\n'
 
             'SampleContract,sample,c101,d101,[u\'2014-12-04 12:10:46 UTC - '
             'Contract record created by system\'],,'
-            '2014-12-04 12:10:46.333445#,SAM,created,My Contract\r\n',
+            'SAM,created,My Contract\r\n',
             result
             )
@@ -308,12 +308,12 @@
         self.assertMatches(
             'class_name,contract_category,contract_id,document_object,'
-            'history,last_product_id,last_transition_date,'
+            'history,last_product_id,'
             'product_object,state,title\r\n'
 
             'SampleContract,sample,c101,d101,[u\'2014-12-04 12:10:46 UTC - '
             'Contract record created by system\'],,'
-            '2014-12-04 12:10:46.333445#,SAM,created,My Contract\r\n',
-            result
-            )
-        return
-
+            'SAM,created,My Contract\r\n',
+            result
+            )
+        return
+
Index: main/waeup.ikoba/trunk/src/waeup/ikoba/customers/workflow.py
===================================================================
--- main/waeup.ikoba/trunk/src/waeup/ikoba/customers/workflow.py	(revision 12209)
+++ main/waeup.ikoba/trunk/src/waeup/ikoba/customers/workflow.py	(revision 12210)
@@ -241,6 +241,5 @@
 @grok.subscribe(IContract, IWorkflowTransitionEvent)
 def handle_contract_transition_event(obj, event):
-    """Append message to contract history and log file, also update
-    last_transition_date when transition happened.
+    """Append message to contract history and log file.
 
     Undo the approval of contract and raise an exception if contract
@@ -256,5 +255,4 @@
     history = IObjectHistory(obj)
     history.addMessage(msg)
-    obj.last_transition_date = datetime.utcnow()
     try:
         customers_container = grok.getSite()['customers']
Index: main/waeup.ikoba/trunk/src/waeup/ikoba/documents/document.py
===================================================================
--- main/waeup.ikoba/trunk/src/waeup/ikoba/documents/document.py	(revision 12209)
+++ main/waeup.ikoba/trunk/src/waeup/ikoba/documents/document.py	(revision 12210)
@@ -86,6 +86,6 @@
     def formatted_transition_date(self):
         try:
-            return self.last_transition_date.strftime('%Y-%m-%d %H:%M:%S')
-        except AttributeError:
+            return self.history.messages[-1].split(' - ')[0]
+        except IndexError:
             return
 
Index: main/waeup.ikoba/trunk/src/waeup/ikoba/documents/interfaces.py
===================================================================
--- main/waeup.ikoba/trunk/src/waeup/ikoba/documents/interfaces.py	(revision 12209)
+++ main/waeup.ikoba/trunk/src/waeup/ikoba/documents/interfaces.py	(revision 12210)
@@ -54,10 +54,4 @@
         )
 
-    last_transition_date = schema.Datetime(
-        title = _(u'Last Transition Date'),
-        required = False,
-        readonly = False,
-        )
-
     def setMD5():
         """Determine md5 checksum of selected files and store checksums as
Index: main/waeup.ikoba/trunk/src/waeup/ikoba/documents/workflow.py
===================================================================
--- main/waeup.ikoba/trunk/src/waeup/ikoba/documents/workflow.py	(revision 12209)
+++ main/waeup.ikoba/trunk/src/waeup/ikoba/documents/workflow.py	(revision 12210)
@@ -134,6 +134,5 @@
 @grok.subscribe(IDocument, IWorkflowTransitionEvent)
 def handle_document_transition_event(obj, event):
-    """Append message to document history and log file and update
-    last_transition_date when transition happened.
+    """Append message to document history and log file.
 
     Undo the verification of document and raise an exception if document
@@ -151,5 +150,4 @@
     history = IObjectHistory(obj)
     history.addMessage(msg)
-    obj.last_transition_date = datetime.utcnow()
     try:
         customers_container = grok.getSite()['customers']